%%% Plots 

A = oo_.dr.ghx;
B = oo_.dr.ghu; 

%%% Theoretical Regression Coefficients

%%% Solving for the variance of the states as a Lyapunov eq
As = A(oo_.dr.inv_order_var(oo_.dr.state_var),:); 
Bs = B(oo_.dr.inv_order_var(oo_.dr.state_var),:); 

Sigma_u = diag([sigma_vtau^2,sigma_vi^2,sigma_g^2]); 

var_s = dlyap(As,Bs*Sigma_u*Bs');

var_y = A*var_s*A' + B*Sigma_u*B'; 
var_y = var_y(oo_.dr.inv_order_var,:);
var_y = var_y(:,oo_.dr.inv_order_var); 

ks = zeros(size(As,1),size(A,1)); %%% Selection matrix for the state variables
for i=1:length(As)
    ks(i,oo_.dr.state_var(i)) = 1; 
end

ky = zeros(size(A,1));  %%% Selection matrix for dectlaration order 

for i=1:length(A)
    ky(i,oo_.dr.inv_order_var(i)) = 1; 
end

ei = [0,1,zeros(1,length(A)-2)];
el = [zeros(1,4),1,zeros(1,length(A)-5)];
eds = [zeros(1,3),1, zeros(1,length(A)-4)];

cov_li = el*var_y*ei';

var_idiff = ei*var_y*ei';

reg_periods = 60; 
beta_l = NaN(reg_periods,1); 
beta_sj = NaN(reg_periods,1); 

for i = 1:reg_periods 
    cov_li = el*((ky*A*ks)^(i-1))*var_y*ei';
    beta_l(i) = cov_li/var_idiff; 
    
    cov_sj = 0; 
    for j = 1:i
        cov_sj = cov_sj + eds*((ky*A*ks)^(j))*var_y*ei';
    end
    
    beta_sj(i) = cov_sj/var_idiff;

    i;
end

beta_L = NaN(reg_periods,1); 
for i =1:reg_periods
    beta_L(i) = sum(beta_l(1:i)); 
end

%%% Impulse Response Functions 
bhg_irf = oo_.irfs.bh_eps_vi; 
idiff_irf = oo_.irfs.i_eps_vi; 
tau_irf = oo_.irfs.tau_eps_vi; 
lambdahat_irf = oo_.irfs.lambda_hat_eps_vi; 
sdiff_irf     = oo_.irfs.sdiff_eps_vi; 


