function [residual, g1, g2, g3] = model_solution_incomplete_mkts_dynamic(y, x, params, steady_state, it_)
%
% Status : Computes dynamic model for Dynare
%
% Inputs :
%   y         [#dynamic variables by 1] double    vector of endogenous variables in the order stored
%                                                 in M_.lead_lag_incidence; see the Manual
%   x         [nperiods by M_.exo_nbr] double     matrix of exogenous variables (in declaration order)
%                                                 for all simulation periods
%   steady_state  [M_.endo_nbr by 1] double       vector of steady state values
%   params    [M_.param_nbr by 1] double          vector of parameter values in declaration order
%   it_       scalar double                       time period for exogenous variables for which to evaluate the model
%
% Outputs:
%   residual  [M_.endo_nbr by 1] double    vector of residuals of the dynamic model equations in order of 
%                                          declaration of the equations.
%                                          Dynare may prepend auxiliary equations, see M_.aux_vars
%   g1        [M_.endo_nbr by #dynamic variables] double    Jacobian matrix of the dynamic model equations;
%                                                           rows: equations in order of declaration
%                                                           columns: variables in order stored in M_.lead_lag_incidence followed by the ones in M_.exo_names
%   g2        [M_.endo_nbr by (#dynamic variables)^2] double   Hessian matrix of the dynamic model equations;
%                                                              rows: equations in order of declaration
%                                                              columns: variables in order stored in M_.lead_lag_incidence followed by the ones in M_.exo_names
%   g3        [M_.endo_nbr by (#dynamic variables)^3] double   Third order derivative matrix of the dynamic model equations;
%                                                              rows: equations in order of declaration
%                                                              columns: variables in order stored in M_.lead_lag_incidence followed by the ones in M_.exo_names
%
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

%
% Model equations
%

residual = zeros(92, 1);
T15 = (1-params(1))*(1-params(1)*params(2))/params(1);
T39 = params(21)*params(41)^(1-params(11));
T42 = T39/(T39+params(20));
T52 = params(20)*params(41)^(params(11)-1);
T54 = T52/(params(21)+T52);
T94 = params(23)/params(11)*params(13)*params(37)/(params(87)*params(39));
T102 = params(23)/params(11)*params(12)/(params(87)*params(38));
T193 = params(76)/(1+params(76));
T199 = params(77)/(1+params(77));
T201 = 1/params(113);
T206 = (params(113)-1)/params(113);
T216 = params(78)/(1+params(78));
T218 = 1/params(112);
T224 = (T218-T201)*y(90);
T233 = params(79)/(1+params(79));
T249 = params(117)^((-(params(113)-1))/params(113));
T253 = (params(116)*params(95))^T206;
T256 = params(119)^T206;
T266 = (params(119)/params(114))^((-(params(112)-1))/params(112));
T268 = (params(112)-1)/params(112);
T269 = params(101)^T268;
T273 = params(102)^T268;
T298 = params(81)/(1+params(81));
T311 = params(82)/(1+params(82));
T326 = params(83)/(1+params(83));
T338 = params(118)^((-(params(113)-1))/params(113));
T341 = (params(116)*params(96))^T206;
T344 = params(120)^T206;
T350 = (params(120)/params(114))^((-(params(112)-1))/params(112));
T353 = params(111)*params(103)^T268;
T358 = (1-params(111))*params(104)^T268;
T388 = params(87)*params(38)^params(11);
T399 = params(10)/(1-params(10))*params(37)^params(11);
T417 = params(12)*params(38)^(params(11)-1);
T440 = params(95)*((1+params(93))/params(34)-1);
T471 = params(96)*((1+params(94))/params(34)-1);
T508 = (1-params(10))/params(10)*params(102)/params(37);
T535 = 1/params(135);
T560 = 1/params(141);
T735 = params(84)/(params(87)*params(38));
T750 = (1-params(105))*params(8)*params(91)/(params(87)*params(38));
T769 = params(85)/(params(87)*params(39)/params(37));
T786 = (1-params(106))*params(16)*params(92)/(params(87)*params(39)/params(37));
lhs =y(27);
rhs =T15*y(37)+params(2)*y(119)+y(74);
residual(1)= lhs-rhs;
lhs =y(28);
rhs =T15*y(38)+params(2)*y(120)+y(75);
residual(2)= lhs-rhs;
lhs =y(29);
rhs =y(27)+T42*(y(39)-y(2));
residual(3)= lhs-rhs;
lhs =y(30);
rhs =y(28)-(y(39)-y(2))*T54+y(40)-y(3);
residual(4)= lhs-rhs;
lhs =y(39);
rhs =params(128)*y(46)+params(129)*y(47)+params(130)*y(48)+params(131)*y(52)+params(144)*y(78)+params(145)*y(79)+T94*y(80)-T102*y(34);
residual(5)= lhs-rhs;
lhs =y(41);
rhs =y(39)*(-T42);
residual(6)= lhs-rhs;
lhs =y(42);
rhs =y(39)*T54;
residual(7)= lhs-rhs;
lhs =y(40);
rhs =y(39)*params(22);
residual(8)= lhs-rhs;
lhs =y(29)+y(40)-y(3);
rhs =y(30)+y(31)-y(1);
residual(9)= lhs-rhs;
lhs =0;
rhs =params(3)*(y(124)-y(48))+y(128)-y(83)+y(121)+y(84)-(y(126)-y(81));
residual(10)= lhs-rhs;
lhs =0;
rhs =params(3)*(y(124)-y(48))+y(128)-y(83)+y(121)-y(43)+y(35)-(y(126)-y(81));
residual(11)= lhs-rhs;
lhs =0;
rhs =y(31)+params(3)*(y(124)-y(48))+y(128)-y(83)+y(121)-y(44)-y(123)+y(36)-(y(126)-y(81));
residual(12)= lhs-rhs;
lhs =0;
rhs =params(3)*(y(125)-y(52))+y(129)-y(85)+y(122)+y(86)-(y(127)-y(82));
residual(13)= lhs-rhs;
lhs =0;
rhs =params(3)*(y(125)-y(52))+y(129)-y(85)+y(122)-y(44)+y(87)-(y(127)-y(82));
residual(14)= lhs-rhs;
lhs =0;
rhs =y(123)+params(3)*(y(125)-y(52))+y(129)-y(85)+y(122)-y(43)-y(31)+y(88)-(y(127)-y(82));
residual(15)= lhs-rhs;
lhs =y(34);
rhs =y(48)*params(28)+(1-params(28))*y(89);
residual(16)= lhs-rhs;
lhs =y(83);
rhs =T193*(y(34)-y(48));
residual(17)= lhs-rhs;
lhs =y(84);
rhs =T199*(y(34)-T201*y(49)+T206*y(93)-y(89)*T206);
residual(18)= lhs-rhs;
lhs =y(35);
rhs =T216*(y(34)-T218*y(50)+T224+y(94)-y(89)*T206);
residual(19)= lhs-rhs;
lhs =y(36);
rhs =T233*(T224+y(34)-T218*y(51)-y(94)*params(111)/(1-params(111))-y(89)*T206);
residual(20)= lhs-rhs;
lhs =y(89);
rhs =T249*(y(49)*T253+y(90)*T256);
residual(21)= lhs-rhs;
lhs =y(90);
rhs =T266*(y(50)*params(111)*T269+y(51)*(1-params(111))*T273+y(94)*params(111)*params(112)/(params(112)-1)*(T269-T273));
residual(22)= lhs-rhs;
lhs =y(80);
rhs =y(52)*params(28)+(1-params(28))*y(91);
residual(23)= lhs-rhs;
lhs =y(85);
rhs =params(80)/(1+params(80))*(y(80)-y(52));
residual(24)= lhs-rhs;
lhs =y(86);
rhs =T298*(y(80)-T201*y(53)+T206*y(96)-T206*y(91));
residual(25)= lhs-rhs;
lhs =y(87);
rhs =T311*(y(80)-T218*y(54)+(T218-T201)*y(92)+T268*y(98)-T206*y(91));
residual(26)= lhs-rhs;
lhs =y(88);
rhs =T326*((T218-T201)*y(92)+y(80)-T218*y(55)+T268*y(97)-T206*y(91));
residual(27)= lhs-rhs;
lhs =y(91);
rhs =T338*(y(53)*T341+y(92)*T344);
residual(28)= lhs-rhs;
lhs =y(92);
rhs =T350*(T353*(y(54)+y(98))+T358*(y(55)+y(97)));
residual(29)= lhs-rhs;
lhs =y(37);
rhs =y(83)+y(46)*params(4)-(1+params(4))*y(70)+y(48)*params(3)-y(41)-y(81);
residual(30)= lhs-rhs;
lhs =y(38);
rhs =y(85)+y(40)+y(47)*params(4)-(1+params(4))*y(71)+y(52)*params(3)-y(42)-y(82);
residual(31)= lhs-rhs;
lhs =T388*(y(46)+params(11)*y(41));
rhs =y(48)*params(20)*params(86)+params(21)*params(86)*T399*(y(52)+params(11)*y(40))+params(21)*T399*params(89)*(y(79)+params(11)*y(40))+y(78)*params(20)*params(88)+T417*(y(34)+(params(11)-1)*y(41));
residual(32)= lhs-rhs;
lhs =params(91)*y(60)+params(84)*y(62)+y(49)*params(95)*(1-1/params(34))+T440*(y(11)-y(29))+params(95)*(1+params(93))/params(34)*y(6);
rhs =params(91)*(1+params(93))*(y(6)-y(29)+y(17))+y(78)*params(88);
residual(33)= lhs-rhs;
lhs =params(92)*y(61)+params(85)*y(63)+y(53)*params(96)*(1-1/params(34))+T471*(y(15)-y(30))+params(96)*(1+params(94))/params(34)*y(7);
rhs =params(92)*(1+params(94))*(y(7)-y(30)+y(18))+y(79)*params(89);
residual(34)= lhs-rhs;
lhs =y(49)+y(99);
rhs =y(58);
residual(35)= lhs-rhs;
lhs =y(53);
rhs =y(59);
residual(36)= lhs-rhs;
lhs =params(91)*y(60);
rhs =y(58)*params(35)+y(50)*params(101)+params(37)*params(104)*params(10)/(1-params(10))*(y(40)+y(55));
residual(37)= lhs-rhs;
lhs =params(92)*y(61);
rhs =y(59)*params(36)+T508*(y(51)-y(40))+y(54)*params(103);
residual(38)= lhs-rhs;
lhs =y(33);
rhs =y(44)+y(123)-y(31)-y(43);
residual(39)= lhs-rhs;
lhs =y(32);
rhs =y(7)+y(31)-y(1)-y(6);
residual(40)= lhs-rhs;
lhs =y(45);
rhs =y(43)-y(44);
residual(41)= lhs-rhs;
lhs =y(118);
rhs =y(31)-y(1);
residual(42)= lhs-rhs;
lhs =y(117);
rhs =y(40)-y(3);
residual(43)= lhs-rhs;
lhs =y(64);
rhs =T535*(y(81)+(1+params(4))*y(70)-y(47)*params(136)-y(52)*params(137)-y(78)*params(150)-y(79)*params(151)-y(83)-y(34)*params(123)-y(80)*params(124));
residual(44)= lhs-rhs;
lhs =y(65);
rhs =T560*(y(82)+(1+params(4))*y(71)-y(46)*params(142)-y(48)*params(143)-y(78)*params(152)-y(79)*params(153)-y(85)-y(34)*params(125)-y(80)*params(126));
residual(45)= lhs-rhs;
lhs =y(66);
rhs =y(46)-y(64);
residual(46)= lhs-rhs;
lhs =y(67);
rhs =y(47)-y(65);
residual(47)= lhs-rhs;
lhs =y(56);
rhs =y(60)-y(41)-y(46);
residual(48)= lhs-rhs;
lhs =y(57);
rhs =y(40)+y(61)-y(42)-y(47);
residual(49)= lhs-rhs;
lhs =y(68);
rhs =y(56)-y(16);
residual(50)= lhs-rhs;
lhs =(params(91)-params(35))*y(69);
rhs =params(91)*y(60)-y(58)*params(35);
residual(51)= lhs-rhs;
lhs =y(113);
rhs =y(43)-y(121);
residual(52)= lhs-rhs;
lhs =y(114);
rhs =y(44)-y(122);
residual(53)= lhs-rhs;
lhs =y(107);
rhs =y(113)-y(114);
residual(54)= lhs-rhs;
lhs =y(100);
rhs =y(51)-y(41)-y(46);
residual(55)= lhs-rhs;
lhs =y(50)*params(101)+y(48)*params(86)+params(12)*y(34)+y(49)*params(95)+y(51)*params(102);
rhs =params(158)*params(159)*(y(103)+y(102))-params(84)*y(62)+params(160)*y(101)+params(95)*(y(11)-y(29))+params(101)*(1+params(93))*(y(6)+y(12)-y(29))+params(102)*(1+params(94))*(y(31)+y(7)+y(13)-y(29)-y(1));
residual(56)= lhs-rhs;
lhs =params(160)*y(101);
rhs =params(160)*(y(46)+y(41))-y(37)*params(160)*(params(18)-1);
residual(57)= lhs-rhs;
lhs =params(4)*y(102);
rhs =y(103)-y(48)*params(3)-y(83)*T193;
residual(58)= lhs-rhs;
lhs =y(46);
rhs =y(70)+y(102);
residual(59)= lhs-rhs;
lhs =y(104);
rhs =y(43)-y(35);
residual(60)= lhs-rhs;
lhs =y(105);
rhs =y(44)-y(87);
residual(61)= lhs-rhs;
lhs =y(106);
rhs =y(104)-y(105);
residual(62)= lhs-rhs;
lhs =y(108);
rhs =y(46)-y(8);
residual(63)= lhs-rhs;
lhs =y(109);
rhs =y(48)-y(10);
residual(64)= lhs-rhs;
lhs =y(110);
rhs =y(47)-y(9);
residual(65)= lhs-rhs;
lhs =y(111);
rhs =y(52)-y(14);
residual(66)= lhs-rhs;
lhs =y(112);
rhs =y(60)-y(17);
residual(67)= lhs-rhs;
lhs =y(115);
rhs =y(56)-y(16);
residual(68)= lhs-rhs;
lhs =y(116);
rhs =y(49)-y(11);
residual(69)= lhs-rhs;
lhs =y(43);
rhs =y(6)*params(5)+y(29)*(1-params(5))*params(6)+y(66)*(1-params(5))*params(7)+y(72);
residual(70)= lhs-rhs;
lhs =y(44);
rhs =y(7)*params(5)+y(30)*(1-params(5))*params(14)+y(67)*(1-params(5))*params(15)+y(61)*(1-params(5))*params(109)+y(73);
residual(71)= lhs-rhs;
lhs =T735*(y(62)-y(41)-y(46));
rhs =T735*params(105)*(y(19)-y(4)-y(8))+T750*(y(17)-y(4)-y(8))+y(46)*(1-params(105))*params(9)+y(78)*params(88)*(1-params(105))*params(107)+y(76);
residual(72)= lhs-rhs;
lhs =T769*(y(40)+y(63)-y(42)-y(47));
rhs =T769*params(106)*(y(3)+y(20)-y(5)-y(9))+T786*(y(3)+y(18)-y(5)-y(9))+y(47)*(1-params(106))*params(17)+y(79)*params(89)*(1-params(106))*params(108)+y(77);
residual(73)= lhs-rhs;
lhs =y(70);
rhs =params(42)*y(21)+params(44)*y(22)+x(it_, 1);
residual(74)= lhs-rhs;
lhs =y(71);
rhs =y(22)*params(43)+y(21)*params(44)+x(it_, 2);
residual(75)= lhs-rhs;
lhs =y(72);
rhs =params(45)*y(23)+params(47)*y(24)+x(it_, 3);
residual(76)= lhs-rhs;
lhs =y(73);
rhs =y(24)*params(46)+y(23)*params(47)+x(it_, 4);
residual(77)= lhs-rhs;
residual(78) = y(74);
residual(79) = y(75);
lhs =y(76);
rhs =params(51)*y(25)+params(53)*y(26)+x(it_, 5);
residual(80)= lhs-rhs;
lhs =y(77);
rhs =y(26)*params(52)+y(25)*params(53)+x(it_, 6);
residual(81)= lhs-rhs;
residual(82) = y(78);
residual(83) = y(79);
residual(84) = y(81);
residual(85) = y(82);
residual(86) = y(99);
residual(87) = y(93);
residual(88) = y(94);
residual(89) = y(95);
residual(90) = y(96);
residual(91) = y(97);
residual(92) = y(98);
if nargout >= 2,
  g1 = zeros(92, 135);

  %
  % Jacobian matrix
  %

T3 = (-1);
T911 = (-((-(T735*params(105)))-T750));
  g1(1,27)=1;
  g1(1,119)=(-params(2));
  g1(1,37)=(-T15);
  g1(1,74)=T3;
  g1(2,28)=1;
  g1(2,120)=(-params(2));
  g1(2,38)=(-T15);
  g1(2,75)=T3;
  g1(3,27)=T3;
  g1(3,29)=1;
  g1(3,2)=T42;
  g1(3,39)=(-T42);
  g1(4,28)=T3;
  g1(4,30)=1;
  g1(4,2)=(-T54);
  g1(4,39)=T54;
  g1(4,3)=1;
  g1(4,40)=T3;
  g1(5,34)=T102;
  g1(5,39)=1;
  g1(5,46)=(-params(128));
  g1(5,47)=(-params(129));
  g1(5,48)=(-params(130));
  g1(5,52)=(-params(131));
  g1(5,78)=(-params(144));
  g1(5,79)=(-params(145));
  g1(5,80)=(-T94);
  g1(6,39)=T42;
  g1(6,41)=1;
  g1(7,39)=(-T54);
  g1(7,42)=1;
  g1(8,39)=(-params(22));
  g1(8,40)=1;
  g1(9,29)=1;
  g1(9,30)=T3;
  g1(9,1)=1;
  g1(9,31)=T3;
  g1(9,3)=T3;
  g1(9,40)=1;
  g1(10,121)=T3;
  g1(10,48)=params(3);
  g1(10,124)=(-params(3));
  g1(10,81)=T3;
  g1(10,126)=1;
  g1(10,83)=1;
  g1(10,128)=T3;
  g1(10,84)=T3;
  g1(11,121)=T3;
  g1(11,35)=T3;
  g1(11,43)=1;
  g1(11,48)=params(3);
  g1(11,124)=(-params(3));
  g1(11,81)=T3;
  g1(11,126)=1;
  g1(11,83)=1;
  g1(11,128)=T3;
  g1(12,121)=T3;
  g1(12,31)=T3;
  g1(12,123)=1;
  g1(12,36)=T3;
  g1(12,44)=1;
  g1(12,48)=params(3);
  g1(12,124)=(-params(3));
  g1(12,81)=T3;
  g1(12,126)=1;
  g1(12,83)=1;
  g1(12,128)=T3;
  g1(13,122)=T3;
  g1(13,52)=params(3);
  g1(13,125)=(-params(3));
  g1(13,82)=T3;
  g1(13,127)=1;
  g1(13,85)=1;
  g1(13,129)=T3;
  g1(13,86)=T3;
  g1(14,122)=T3;
  g1(14,44)=1;
  g1(14,52)=params(3);
  g1(14,125)=(-params(3));
  g1(14,82)=T3;
  g1(14,127)=1;
  g1(14,85)=1;
  g1(14,129)=T3;
  g1(14,87)=T3;
  g1(15,122)=T3;
  g1(15,31)=1;
  g1(15,123)=T3;
  g1(15,43)=1;
  g1(15,52)=params(3);
  g1(15,125)=(-params(3));
  g1(15,82)=T3;
  g1(15,127)=1;
  g1(15,85)=1;
  g1(15,129)=T3;
  g1(15,88)=T3;
  g1(16,34)=1;
  g1(16,48)=(-params(28));
  g1(16,89)=(-(1-params(28)));
  g1(17,34)=(-T193);
  g1(17,48)=T193;
  g1(17,83)=1;
  g1(18,34)=(-T199);
  g1(18,49)=(-(T199*(-T201)));
  g1(18,84)=1;
  g1(18,89)=(-(T199*(-T206)));
  g1(18,93)=(-(T199*T206));
  g1(19,34)=(-T216);
  g1(19,35)=1;
  g1(19,50)=(-(T216*(-T218)));
  g1(19,89)=(-(T216*(-T206)));
  g1(19,90)=(-(T216*(T218-T201)));
  g1(19,94)=(-T216);
  g1(20,34)=(-T233);
  g1(20,36)=1;
  g1(20,51)=(-(T233*(-T218)));
  g1(20,89)=(-(T233*(-T206)));
  g1(20,90)=(-((T218-T201)*T233));
  g1(20,94)=(-(T233*(-(params(111)/(1-params(111))))));
  g1(21,49)=(-(T249*T253));
  g1(21,89)=1;
  g1(21,90)=(-(T249*T256));
  g1(22,50)=(-(T266*params(111)*T269));
  g1(22,51)=(-(T266*(1-params(111))*T273));
  g1(22,90)=1;
  g1(22,94)=(-(T266*params(111)*params(112)/(params(112)-1)*(T269-T273)));
  g1(23,52)=(-params(28));
  g1(23,80)=1;
  g1(23,91)=(-(1-params(28)));
  g1(24,52)=params(80)/(1+params(80));
  g1(24,80)=(-(params(80)/(1+params(80))));
  g1(24,85)=1;
  g1(25,53)=(-(T298*(-T201)));
  g1(25,80)=(-T298);
  g1(25,86)=1;
  g1(25,91)=(-(T298*(-T206)));
  g1(25,96)=(-(T206*T298));
  g1(26,54)=(-(T311*(-T218)));
  g1(26,80)=(-T311);
  g1(26,87)=1;
  g1(26,91)=(-(T311*(-T206)));
  g1(26,92)=(-((T218-T201)*T311));
  g1(26,98)=(-(T268*T311));
  g1(27,55)=(-(T326*(-T218)));
  g1(27,80)=(-T326);
  g1(27,88)=1;
  g1(27,91)=(-(T326*(-T206)));
  g1(27,92)=(-((T218-T201)*T326));
  g1(27,97)=(-(T268*T326));
  g1(28,53)=(-(T338*T341));
  g1(28,91)=1;
  g1(28,92)=(-(T338*T344));
  g1(29,54)=(-(T350*T353));
  g1(29,55)=(-(T350*T358));
  g1(29,92)=1;
  g1(29,97)=(-(T350*T358));
  g1(29,98)=(-(T350*T353));
  g1(30,37)=1;
  g1(30,41)=1;
  g1(30,46)=(-params(4));
  g1(30,48)=(-params(3));
  g1(30,70)=1+params(4);
  g1(30,81)=1;
  g1(30,83)=T3;
  g1(31,38)=1;
  g1(31,40)=T3;
  g1(31,42)=1;
  g1(31,47)=(-params(4));
  g1(31,52)=(-params(3));
  g1(31,71)=1+params(4);
  g1(31,82)=1;
  g1(31,85)=T3;
  g1(32,34)=(-T417);
  g1(32,40)=(-(params(11)*params(21)*params(86)*T399+params(11)*params(21)*T399*params(89)));
  g1(32,41)=params(11)*T388-(params(11)-1)*T417;
  g1(32,46)=T388;
  g1(32,48)=(-(params(20)*params(86)));
  g1(32,52)=(-(params(21)*params(86)*T399));
  g1(32,78)=(-(params(20)*params(88)));
  g1(32,79)=(-(params(21)*T399*params(89)));
  g1(33,29)=(-T440)-(-(params(91)*(1+params(93))));
  g1(33,6)=params(95)*(1+params(93))/params(34)-params(91)*(1+params(93));
  g1(33,11)=T440;
  g1(33,49)=params(95)*(1-1/params(34));
  g1(33,17)=(-(params(91)*(1+params(93))));
  g1(33,60)=params(91);
  g1(33,62)=params(84);
  g1(33,78)=(-params(88));
  g1(34,30)=(-T471)-(-(params(92)*(1+params(94))));
  g1(34,7)=params(96)*(1+params(94))/params(34)-params(92)*(1+params(94));
  g1(34,15)=T471;
  g1(34,53)=params(96)*(1-1/params(34));
  g1(34,18)=(-(params(92)*(1+params(94))));
  g1(34,61)=params(92);
  g1(34,63)=params(85);
  g1(34,79)=(-params(89));
  g1(35,49)=1;
  g1(35,58)=T3;
  g1(35,99)=1;
  g1(36,53)=1;
  g1(36,59)=T3;
  g1(37,40)=(-(params(37)*params(104)*params(10)/(1-params(10))));
  g1(37,50)=(-params(101));
  g1(37,55)=(-(params(37)*params(104)*params(10)/(1-params(10))));
  g1(37,58)=(-params(35));
  g1(37,60)=params(91);
  g1(38,40)=T508;
  g1(38,51)=(-T508);
  g1(38,54)=(-params(103));
  g1(38,59)=(-params(36));
  g1(38,61)=params(92);
  g1(39,31)=1;
  g1(39,123)=T3;
  g1(39,33)=1;
  g1(39,43)=1;
  g1(39,44)=T3;
  g1(40,1)=1;
  g1(40,31)=T3;
  g1(40,32)=1;
  g1(40,6)=1;
  g1(40,7)=T3;
  g1(41,43)=T3;
  g1(41,44)=1;
  g1(41,45)=1;
  g1(42,1)=1;
  g1(42,31)=T3;
  g1(42,118)=1;
  g1(43,3)=1;
  g1(43,40)=T3;
  g1(43,117)=1;
  g1(44,34)=(-(T535*(-params(123))));
  g1(44,47)=(-(T535*(-params(136))));
  g1(44,52)=(-(T535*(-params(137))));
  g1(44,64)=1;
  g1(44,70)=(-((1+params(4))*T535));
  g1(44,78)=(-(T535*(-params(150))));
  g1(44,79)=(-(T535*(-params(151))));
  g1(44,80)=(-(T535*(-params(124))));
  g1(44,81)=(-T535);
  g1(44,83)=T535;
  g1(45,34)=(-(T560*(-params(125))));
  g1(45,46)=(-(T560*(-params(142))));
  g1(45,48)=(-(T560*(-params(143))));
  g1(45,65)=1;
  g1(45,71)=(-((1+params(4))*T560));
  g1(45,78)=(-(T560*(-params(152))));
  g1(45,79)=(-(T560*(-params(153))));
  g1(45,80)=(-(T560*(-params(126))));
  g1(45,82)=(-T560);
  g1(45,85)=T560;
  g1(46,46)=T3;
  g1(46,64)=1;
  g1(46,66)=1;
  g1(47,47)=T3;
  g1(47,65)=1;
  g1(47,67)=1;
  g1(48,41)=1;
  g1(48,46)=1;
  g1(48,56)=1;
  g1(48,60)=T3;
  g1(49,40)=T3;
  g1(49,42)=1;
  g1(49,47)=1;
  g1(49,57)=1;
  g1(49,61)=T3;
  g1(50,16)=1;
  g1(50,56)=T3;
  g1(50,68)=1;
  g1(51,58)=params(35);
  g1(51,60)=(-params(91));
  g1(51,69)=params(91)-params(35);
  g1(52,121)=1;
  g1(52,43)=T3;
  g1(52,113)=1;
  g1(53,122)=1;
  g1(53,44)=T3;
  g1(53,114)=1;
  g1(54,107)=1;
  g1(54,113)=T3;
  g1(54,114)=1;
  g1(55,41)=1;
  g1(55,46)=1;
  g1(55,51)=T3;
  g1(55,100)=1;
  g1(56,29)=(-((-params(95))-params(101)*(1+params(93))-params(102)*(1+params(94))));
  g1(56,1)=params(102)*(1+params(94));
  g1(56,31)=(-(params(102)*(1+params(94))));
  g1(56,34)=params(12);
  g1(56,6)=(-(params(101)*(1+params(93))));
  g1(56,7)=(-(params(102)*(1+params(94))));
  g1(56,48)=params(86);
  g1(56,11)=(-params(95));
  g1(56,49)=params(95);
  g1(56,12)=(-(params(101)*(1+params(93))));
  g1(56,50)=params(101);
  g1(56,13)=(-(params(102)*(1+params(94))));
  g1(56,51)=params(102);
  g1(56,62)=params(84);
  g1(56,101)=(-params(160));
  g1(56,102)=(-(params(158)*params(159)));
  g1(56,103)=(-(params(158)*params(159)));
  g1(57,37)=params(160)*(params(18)-1);
  g1(57,41)=(-params(160));
  g1(57,46)=(-params(160));
  g1(57,101)=params(160);
  g1(58,48)=params(3);
  g1(58,83)=T193;
  g1(58,102)=params(4);
  g1(58,103)=T3;
  g1(59,46)=1;
  g1(59,70)=T3;
  g1(59,102)=T3;
  g1(60,35)=1;
  g1(60,43)=T3;
  g1(60,104)=1;
  g1(61,44)=T3;
  g1(61,87)=1;
  g1(61,105)=1;
  g1(62,104)=T3;
  g1(62,105)=1;
  g1(62,106)=1;
  g1(63,8)=1;
  g1(63,46)=T3;
  g1(63,108)=1;
  g1(64,10)=1;
  g1(64,48)=T3;
  g1(64,109)=1;
  g1(65,9)=1;
  g1(65,47)=T3;
  g1(65,110)=1;
  g1(66,14)=1;
  g1(66,52)=T3;
  g1(66,111)=1;
  g1(67,17)=1;
  g1(67,60)=T3;
  g1(67,112)=1;
  g1(68,16)=1;
  g1(68,56)=T3;
  g1(68,115)=1;
  g1(69,11)=1;
  g1(69,49)=T3;
  g1(69,116)=1;
  g1(70,29)=(-((1-params(5))*params(6)));
  g1(70,6)=(-params(5));
  g1(70,43)=1;
  g1(70,66)=(-((1-params(5))*params(7)));
  g1(70,72)=T3;
  g1(71,30)=(-((1-params(5))*params(14)));
  g1(71,7)=(-params(5));
  g1(71,44)=1;
  g1(71,61)=(-((1-params(5))*params(109)));
  g1(71,67)=(-((1-params(5))*params(15)));
  g1(71,73)=T3;
  g1(72,4)=T911;
  g1(72,41)=(-T735);
  g1(72,8)=T911;
  g1(72,46)=(-T735)-(1-params(105))*params(9);
  g1(72,17)=(-T750);
  g1(72,19)=(-(T735*params(105)));
  g1(72,62)=T735;
  g1(72,76)=T3;
  g1(72,78)=(-(params(88)*(1-params(105))*params(107)));
  g1(73,3)=(-(T769*params(106)+T786));
  g1(73,40)=T769;
  g1(73,5)=(-((-(T769*params(106)))-T786));
  g1(73,42)=(-T769);
  g1(73,9)=(-((-(T769*params(106)))-T786));
  g1(73,47)=(-T769)-(1-params(106))*params(17);
  g1(73,18)=(-T786);
  g1(73,20)=(-(T769*params(106)));
  g1(73,63)=T769;
  g1(73,77)=T3;
  g1(73,79)=(-(params(89)*(1-params(106))*params(108)));
  g1(74,21)=(-params(42));
  g1(74,70)=1;
  g1(74,22)=(-params(44));
  g1(74,130)=T3;
  g1(75,21)=(-params(44));
  g1(75,22)=(-params(43));
  g1(75,71)=1;
  g1(75,131)=T3;
  g1(76,23)=(-params(45));
  g1(76,72)=1;
  g1(76,24)=(-params(47));
  g1(76,132)=T3;
  g1(77,23)=(-params(47));
  g1(77,24)=(-params(46));
  g1(77,73)=1;
  g1(77,133)=T3;
  g1(78,74)=1;
  g1(79,75)=1;
  g1(80,25)=(-params(51));
  g1(80,76)=1;
  g1(80,26)=(-params(53));
  g1(80,134)=T3;
  g1(81,25)=(-params(53));
  g1(81,26)=(-params(52));
  g1(81,77)=1;
  g1(81,135)=T3;
  g1(82,78)=1;
  g1(83,79)=1;
  g1(84,81)=1;
  g1(85,82)=1;
  g1(86,99)=1;
  g1(87,93)=1;
  g1(88,94)=1;
  g1(89,95)=1;
  g1(90,96)=1;
  g1(91,97)=1;
  g1(92,98)=1;

if nargout >= 3,
  %
  % Hessian matrix
  %

  g2 = sparse([],[],[],92,18225);
if nargout >= 4,
  %
  % Third order derivatives
  %

  g3 = sparse([],[],[],92,2460375);
end
end
end
end
